Index: src/sharedinfrastructure.cpp
===================================================================
--- src/sharedinfrastructure.cpp	(revision 0)
+++ src/sharedinfrastructure.cpp	(revision 0)
@@ -0,0 +1,941 @@
+/* $Id: sharedinfrastructure.cpp $ */
+
+/** @file sharedinfrastructure.cpp
+ * This file deals with using shared infrastructures and relative cost/income */
+
+#include "stdafx.h"
+#include "openttd.h"
+#include "bridge_map.h"
+#include "debug.h"
+#include "functions.h"
+#include "landscape.h"
+#include "npf.h"
+#include "aystar.h"
+#include "pathfind.h"
+#include "station_map.h"
+#include "tile_type.h"
+#include "depot_base.h"
+#include "tunnel_map.h"
+#include "network/network.h"
+#include "water_map.h"
+#include "sharedinfrastructure.h"
+#include "variables.h"
+#include "settings_type.h"
+#include "player_func.h"
+#include "player_base.h"
+#include "vehicle_base.h"
+#include "cargotype.h"
+#include "newgrf_cargo.h"
+#include "aircraft.h"
+#include "news_func.h"
+#include "strings_func.h"
+#include "station_base.h"
+#include "depot_map.h"
+#include "window_func.h"
+#include "command_func.h"
+#include "vehicle_func.h"
+#include "train.h"
+
+#include "table/strings.h"
+
+/* variables for player's shared infrastructure GUI */
+bool _si_railway_tracks;
+bool _si_railway_stations;
+bool _si_railway_depots;
+bool _si_airports;
+bool _si_road_depots;
+bool _si_road_stops;
+bool _si_water_depots;
+bool _si_harbours;
+uint16 _si_tontile_cost;
+uint16 _si_landing_fee;
+uint8 _si_provision;
+uint8 _si_road_stops_fee;
+uint8 _si_harbours_fee;
+
+/** Fonctions to check if vehicle can enter tiles
+ * @param tile Tile to enter
+ * @param owner Vehicle's owner
+ */
+
+bool SharedTracks(TileIndex tile, Owner owner)
+{
+	Owner player = GetTileOwner(tile);
+	if (!IsValidPlayer (player)) return true;  // no owner ? just go then, and don't assert on next line
+	Player *p = GetPlayer(player);
+
+	return _settings_game.sharing.shared_player_level ? p->shared_railway_tracks[0] : _settings_game.sharing.shared_railway_tracks;
+}
+
+bool SharedRailwayStations(TileIndex tile, Owner owner)
+{
+	Owner player = GetTileOwner(tile);
+	if (!IsValidPlayer (player)) return true;
+	Player *p = GetPlayer(player);
+	return _settings_game.sharing.shared_player_level ? p->shared_railway_stations[0] : _settings_game.sharing.shared_railway_stations;
+}
+
+bool SharedRailwayDepots(TileIndex tile, Owner owner)
+{
+	Owner player = GetTileOwner(tile);
+	if (!IsValidPlayer (player)) return true;
+	Player *p = GetPlayer(player);
+	return _settings_game.sharing.shared_player_level ? p->shared_railway_depots[0] : _settings_game.sharing.shared_railway_depots;
+}
+
+bool SharedRoadDepots(TileIndex tile, Owner owner)
+{
+	Owner player = GetTileOwner(tile);
+	if (!IsValidPlayer (player)) return true;
+	Player *p = GetPlayer(player);
+	return _settings_game.sharing.shared_player_level ? p->shared_road_depots[0] : _settings_game.sharing.shared_road_depots;
+}
+
+bool SharedRoadStops(TileIndex tile, Owner owner)
+{
+	Owner player = GetTileOwner(tile);
+	if (!IsValidPlayer (player)) return true;
+	Player *p = GetPlayer(player);
+	return _settings_game.sharing.shared_player_level ? p->shared_road_stops[0] : _settings_game.sharing.shared_road_stops;
+}
+
+bool SharedWaterDepots(TileIndex tile, Owner owner)
+{
+	Owner player = GetTileOwner(tile);
+	if (!IsValidPlayer (player)) return true;
+	Player *p = GetPlayer(player);
+	return _settings_game.sharing.shared_player_level ? p->shared_water_depots[0] : _settings_game.sharing.shared_water_depots;
+}
+
+bool SharedHarbours(TileIndex tile, Owner owner)
+{
+	Owner player = GetTileOwner(tile);
+	if (!IsValidPlayer (player)) return true;
+	Player *p = GetPlayer(player);
+	return _settings_game.sharing.shared_player_level ? p->shared_harbours[0] : _settings_game.sharing.shared_harbours;
+}
+
+bool SharedAirports(TileIndex tile, Owner owner)
+{
+	Owner player = GetTileOwner(tile);
+	if (!IsValidPlayer (player)) return true;
+	Player *p = GetPlayer(player);
+	return _settings_game.sharing.shared_player_level ? p->shared_airports[0] : _settings_game.sharing.shared_airports;
+}
+
+bool SharedDepotTransport(TileIndex tile, Owner owner, TransportType type)
+{
+  switch (type) {
+	  case TRANSPORT_RAIL: return SharedRailwayDepots(tile,owner);
+			       break;
+	  case TRANSPORT_ROAD: return SharedRoadDepots(tile,owner);
+			       break;
+	  case TRANSPORT_WATER: return SharedWaterDepots(tile,owner);
+				break;
+	  default:
+		  return false;
+		  break;
+  }
+  return false;
+}
+
+bool SharedDepotVehicleType(TileIndex tile, Owner owner, VehicleType type)
+{
+  switch (type) {
+	  case VEH_TRAIN: return SharedRailwayDepots(tile,owner);
+			       break;
+	  case VEH_ROAD: return SharedRoadDepots(tile,owner);
+			       break;
+	  case VEH_SHIP: return SharedWaterDepots(tile,owner);
+				break;
+	  case VEH_AIRCRAFT: return SharedAirports(tile,owner);
+				break;
+	  default: return 0;
+  }
+  return 0;
+}
+
+
+bool SharedStation(TileIndex tile, Owner owner, VehicleType type)
+{
+  switch (type) {
+	  case VEH_TRAIN: return SharedRailwayStations(tile,owner);
+			       break;
+	  case VEH_ROAD: return SharedRoadStops(tile,owner);
+			       break;
+	  case VEH_SHIP: return SharedHarbours(tile,owner);
+				break;
+	  case VEH_AIRCRAFT: return SharedAirports(tile,owner);
+				break;
+	  default: return 0;
+  }
+  return 0;
+}
+
+/** Calculate provision for action in shared depots.
+ * @param cost Command cost
+ * @param owner Depot owner
+ * @param flags Command flag
+ */
+void SharedDepotProvision(CommandCost cost, Owner owner, uint32 flags)
+{	
+	if ((_current_player != owner) && (!(flags & DC_QUERY_COST)) && (flags & DC_EXEC)) {
+	  	PlayerByte curr = _current_player;
+		if (IsValidPlayer (owner)) {
+			Player *p = GetPlayer(owner);
+
+			uint16 provision_percent = _settings_game.sharing.shared_player_level ? p->shared_provision[0] : _settings_game.sharing.shared_provision;
+			OverflowSafeInt64 provision = (cost.GetCost() * (int64)provision_percent) / 100;
+
+			_current_player = owner;
+			SubtractMoneyFromPlayer(CommandCost(EXPENSES_SHARED_INF_INC,-provision));
+
+			_current_player = curr;
+			SubtractMoneyFromPlayer(CommandCost(EXPENSES_SHARED_INF_RUN,provision));
+		}
+	}
+}
+
+/** Fonctions to activate/desactivate simultaneously railway tracks and stations sharing.
+ * used in patch setting menu
+ */
+int32 SettingsEnableSharedRailwayStations(int32 p1)
+{
+  GameSettings *ptc = (_game_mode == GM_MENU) ? &_settings_newgame : &_settings_game;
+  if(p1)
+    ptc->sharing.shared_railway_tracks=1;
+  return 0;
+}
+
+int32 SettingsEnableSharedRailwayTracks(int32 p1)
+{
+  GameSettings *ptc = (_game_mode == GM_MENU) ? &_settings_newgame : &_settings_game;
+  if(!p1)
+  {
+  	 ptc->sharing.shared_railway_stations=0;
+  	 ptc->sharing.shared_railway_depots=0;
+  }
+  return 0;
+}
+
+/** Calculate track sharing cost & income for all players
+ * called each month
+ */
+void SharedTracksPayment()
+{	
+	Vehicle *v;
+	Player *p;
+	OverflowSafeInt64 tontile_total_income[MAX_PLAYERS]={ 0 };
+	OverflowSafeInt64 tontile_total_cost[MAX_PLAYERS]={ 0 };
+	
+	FOR_ALL_VEHICLES(v) {
+		PlayerID old_player = _current_player;
+		FOR_ALL_PLAYERS(p) {
+			OverflowSafeInt64 cost = 0;
+			if (v->shared_tontiles[p->index] > 0) {
+				uint16 ton_cost = _settings_game.sharing.shared_player_level ? p->shared_tontile_cost[0] : _settings_game.sharing.shared_tontile_cost;
+				cost = max (((v->shared_tontiles[p->index] * ton_cost) / 1000), (OverflowSafeInt64)ton_cost);
+
+				v->profit_this_year -= cost << 8;
+
+				_current_player = v->owner;
+				SubtractMoneyFromPlayer(CommandCost(EXPENSES_SHARED_INF_RUN,cost));
+				tontile_total_cost[v->owner]+=cost;
+
+				_current_player = p->index;
+				SubtractMoneyFromPlayer(CommandCost(EXPENSES_SHARED_INF_INC,-cost));
+				tontile_total_income[p->index]+=cost;
+
+				v->shared_tontiles[p->index] = 0;
+			}
+		}
+		_current_player = old_player;
+	}
+
+	PlayerID old_player = _current_player;
+	FOR_ALL_PLAYERS(p) {
+		/* Show total shared tracks cost & income animation above HQ */
+		if (p->location_of_house != 0) {
+			_current_player = p->index;
+			TileIndex tile = p->location_of_house;
+			uint hq_x = TileX(tile) * 16;
+			uint hq_y = TileY(tile) * 16;
+			uint hq_z= GetSlopeZ(TileX(tile), TileX(tile)) + 80; // show animation above HQ, not inside.
+			if (tontile_total_income[p->index] > 0)
+				ShowCostOrIncomeAnimation( hq_x, hq_y, hq_z, -tontile_total_income[p->index]);
+			if (tontile_total_cost[p->index] > 0)
+				ShowCostOrIncomeAnimation( hq_x, hq_y + 10 , hq_z, tontile_total_cost[p->index]); // show cost under income
+		}
+		_current_player = old_player;
+	}
+}
+
+/** Calculate station entrance fee for vehicle
+ * @param station_owner Station owner
+ * @param vehicle_owner Vehicle owner
+ * @param cargo_capacity maximum cargo of vehicle
+ */
+void SharedStationFee(Owner station_owner, VehicleID vehicle)
+{	
+	PlayerID old_player = _current_player;	
+	if (IsValidPlayer (station_owner)) {
+		Player *p = GetPlayer(station_owner);
+		Vehicle *v = GetVehicle(vehicle);
+		uint16 ton_cost = 0, cargo_capacity = 0;
+		const AircraftVehicleInfo *avi;
+
+		switch (v->type) {
+			case VEH_TRAIN:
+				break;
+			case VEH_ROAD:
+				/* count 10 passengers for 1 ton of cargo */
+				cargo_capacity = (IsCargoInClass(v->cargo_type, CC_PASSENGERS)) ? (v->cargo_cap / 10) : v->cargo_cap;
+				ton_cost = _settings_game.sharing.shared_player_level ? p->shared_road_stops_fee[0] : _settings_game.sharing.shared_road_stops_fee;
+				break;
+			case VEH_SHIP: 
+				cargo_capacity = v->cargo_cap;
+				ton_cost = _settings_game.sharing.shared_player_level ? p->shared_harbours_fee[0] : _settings_game.sharing.shared_harbours_fee;
+				break;
+			case VEH_AIRCRAFT:
+				/* count cargo capacity relative to goods */
+				avi = AircraftVehInfo(v->engine_type);
+				cargo_capacity = AircraftDefaultCargoCapacity(CT_GOODS, avi);
+				ton_cost = _settings_game.sharing.shared_player_level ? p->shared_landing_fee[0] : _settings_game.sharing.shared_landing_fee;
+				break;
+			default: break;
+		}
+
+		OverflowSafeInt64 station_fee = (cargo_capacity * ton_cost);
+	
+		_current_player = station_owner;
+		SubtractMoneyFromPlayer(CommandCost(EXPENSES_SHARED_INF_INC, -station_fee));
+	
+		_current_player = v->owner;
+		SubtractMoneyFromPlayer(CommandCost(EXPENSES_SHARED_INF_RUN, station_fee));
+
+		_current_player = old_player;
+
+		if (station_fee > 0) {
+			/* remove station fee from vehicle profit */
+			v->profit_this_year -= station_fee << 8;
+
+			/** show vehicle cost animation for every player
+			 * (do not show it as income animation, even for station owner
+			 * as it can be confusing)
+			 */
+			ShowCostOrIncomeAnimation(v->x_pos, v->y_pos + 10 , v->z_pos, station_fee);
+		}
+	}
+}
+
+/* return closing infrastructure as bitmask */
+uint GetSharedCloseBits(PlayerID player)
+{
+	Player *p = GetPlayer(player);
+	uint close_bits = 0;
+	if ((p->shared_railway_tracks[0]) && !(p->shared_railway_tracks[1])) close_bits |= SHARED_RAILWAY_TRACKS;
+	if ((p->shared_railway_stations[0]) && !(p->shared_railway_stations[1])) close_bits |= SHARED_RAILWAY_STATIONS;
+	if ((p->shared_railway_depots[0]) && !(p->shared_railway_depots[1])) close_bits |= SHARED_RAILWAY_DEPOTS;
+	if ((p->shared_airports[0]) && !(p->shared_airports[1])) close_bits |= SHARED_AIRPORTS;
+	if ((p->shared_road_depots[0]) && !(p->shared_road_depots[1])) close_bits |= SHARED_ROAD_DEPOTS;
+	if ((p->shared_road_stops[0]) && !(p->shared_road_stops[1])) close_bits |= SHARED_ROAD_STOPS;
+	if ((p->shared_water_depots[0]) && !(p->shared_water_depots[1])) close_bits |= SHARED_WATER_DEPOTS;
+	if ((p->shared_harbours[0]) && !(p->shared_harbours[1])) close_bits |= SHARED_HARBOURS;
+	return close_bits;
+}
+
+/* set player sharing settings at end of activation delay */
+void SharedSettingDelay()
+{	
+	Player *p;
+	uint close_bits = 0;
+	
+	FOR_ALL_PLAYERS(p) {
+		switch (p->shared_change_months) {
+			case 0:
+				break;
+
+			case 1:
+				/* get closing infrastructure(s) */
+				close_bits = GetSharedCloseBits(p->index);
+				/* remove vehicle from closing infrastructure(s) */
+				OnSharedClose(p->index, close_bits);
+				/* time to change settings ! */
+				p->shared_railway_tracks[0] = p->shared_railway_tracks[1];
+				p->shared_railway_stations[0] = p->shared_railway_stations[1];
+				p->shared_railway_depots[0] = p->shared_railway_depots[1];
+				p->shared_tontile_cost[0] = p->shared_tontile_cost[1];
+				p->shared_road_stops_fee[0] = p->shared_road_stops_fee[1];
+				p->shared_harbours_fee[0] = p->shared_harbours_fee[1];
+				p->shared_airports[0] = p->shared_airports[1];
+				p->shared_landing_fee[0] = p->shared_landing_fee[1];
+				p->shared_road_depots[0] = p->shared_road_depots[1];
+				p->shared_road_stops[0] = p->shared_road_stops[1];
+				p->shared_water_depots[0] = p->shared_water_depots[1];
+				p->shared_harbours[0] = p->shared_harbours[1];
+				p->shared_provision[0] = p->shared_provision[1];
+
+				p->shared_change_months = 0;
+				break;
+
+			default :
+				p->shared_change_months--;
+				break;
+		}
+	}
+}
+
+/** Change player shared bool setting.
+ * @param tile unused
+ * @param flags unused
+ * @param p1 packed new boolean values
+ * @param p2 unused
+ */
+CommandCost CmdSetSharedBoolValues(TileIndex tile, uint32 flags, uint32 p1, uint32 p2)
+{
+	Player *p = GetPlayer(_current_player);
+
+	/* fix : do not send news twice if values are already updated */
+	uint32 check = (uint)p->shared_railway_tracks[1] | (uint)p->shared_railway_stations[1] << 1 | (uint)p->shared_railway_depots[1] << 2
+		 | (uint)p->shared_airports[1] << 3 | (uint)p->shared_road_depots[1] << 4 | (uint)p->shared_road_stops[1] << 5
+		 | (uint)p->shared_water_depots[1] << 6 | (uint)p->shared_harbours[1] << 7;
+	
+	/* set new value */
+	p->shared_railway_tracks[1]= HasBit(p1, 0);
+	p->shared_railway_stations[1]= HasBit(p1, 1);
+	p->shared_railway_depots[1]= HasBit(p1, 2);
+	p->shared_airports[1]= HasBit(p1, 3);
+	p->shared_road_depots[1]= HasBit(p1, 4);
+	p->shared_road_stops[1]= HasBit(p1, 5);
+	p->shared_water_depots[1]= HasBit(p1, 6);
+	p->shared_harbours[1]= HasBit(p1, 7);
+
+	/* reset timer for setting sharing value */
+	p->shared_change_months = _settings_game.sharing.shared_delay;
+
+	/* immediatly apply setting if patch delay is set to 0 */
+	if (_settings_game.sharing.shared_delay == 0) {
+		/* get closing infrastructure and remove vehicle */
+		if (check != p1) {
+			uint close_bits = GetSharedCloseBits(p->index);
+			OnSharedClose(p->index, close_bits);
+		}
+		/* update settings */
+		p->shared_railway_tracks[0]= HasBit(p1, 0);
+		p->shared_railway_stations[0]= HasBit(p1, 1);
+		p->shared_railway_depots[0]= HasBit(p1, 2);
+		p->shared_airports[0]= HasBit(p1, 3);
+		p->shared_road_depots[0]= HasBit(p1, 4);
+		p->shared_road_stops[0]= HasBit(p1, 5);
+		p->shared_water_depots[0]= HasBit(p1, 6);
+		p->shared_harbours[0]= HasBit(p1, 7);
+	}
+
+	/* send a news message to all players about this change */
+	if (check != p1) {
+		TileIndex t_news = p->location_of_house > 0 ? p->location_of_house : p->last_build_coordinate;
+		SetDParam(0, p->index);
+		SetDParam(1, p->index);
+		AddNewsItem(STR_SHARED_CHANGE_BOOL_VALUE,
+			NS_COMPANY_SHARING,
+			t_news,
+			0);
+	}
+
+	return CommandCost();
+}
+
+/** Change player shared int setting.
+ * @param tile unused
+ * @param flags unused
+ * @param p1 packed new int values (tontile_cost, road_stops_fee, harbours_fee)
+ * @param p2 packed new int values (landing_fee, depot_provision)
+ */
+CommandCost CmdSetSharedIntValues(TileIndex tile, uint32 flags, uint32 p1, uint32 p2)
+{
+	Player *p = GetPlayer(_current_player);
+
+	/* fix : do not send news twice if values are already updated */
+	uint32 check = p->shared_tontile_cost[1] | p->shared_road_stops_fee[1] << 16 | p->shared_harbours_fee[1] << 24;
+	uint32 check2 = p->shared_landing_fee[1] | p->shared_provision[1] << 16;
+
+	/* set new value from p1 */
+	p->shared_tontile_cost[1] = GB(p1, 0, 16);
+	p->shared_road_stops_fee[1] = GB(p1, 16, 8);
+	p->shared_harbours_fee[1] = GB(p1, 24, 8);
+	/* set new value from p2 */
+	p->shared_landing_fee[1] = GB(p2, 0, 16);
+	p->shared_provision[1] = GB(p2, 16, 8);
+
+	/* reset timer for setting sharing value */
+	p->shared_change_months = _settings_game.sharing.shared_delay;
+
+	/* immediatly apply setting if patch delay is set to 0 */
+	if (_settings_game.sharing.shared_delay == 0) {
+		p->shared_tontile_cost[0] = GB(p1, 0, 16);
+		p->shared_road_stops_fee[0] = GB(p1, 16, 8);
+		p->shared_harbours_fee[0] = GB(p1, 24, 8);
+		p->shared_landing_fee[0] = GB(p2, 0, 16);
+		p->shared_provision[0] = GB(p2, 16, 8);
+	}
+
+	/* send a news message to all players about this change */
+	if (check != p1 || check2 != p2) {
+		TileIndex t_news = p->location_of_house > 0 ? p->location_of_house : p->last_build_coordinate;
+		SetDParam(0, p->index);
+		SetDParam(1, p->index);
+		AddNewsItem(STR_SHARED_CHANGE_INT_VALUE,
+			NS_COMPANY_SHARING,
+			t_news,
+			0);
+	}
+
+	return CommandCost();
+}
+
+/* borrowed */
+static const byte _vehicle_initial_x_fract[4] = {10, 8, 4,  8};
+static const byte _vehicle_initial_y_fract[4] = { 8, 4, 8, 10};
+static void TrainMovedChangeSignals(TileIndex tile, DiagDirection dir)
+{
+	if (IsTileType(tile, MP_RAILWAY) &&
+			GetRailTileType(tile) == RAIL_TILE_SIGNALS) {
+		TrackdirBits tracks = TrackBitsToTrackdirBits(GetTrackBits(tile)) & DiagdirReachesTrackdirs(dir);
+		Trackdir trackdir = FindFirstTrackdir(tracks);
+		UpdateSignalsOnSegment(tile, TrackdirToExitdir(trackdir), GetTileOwner(tile));
+	}
+}
+
+bool SharedCloseDepotTeleport (VehicleID vehicle, DepotID depot)
+{
+	if (IsValidDepotID(depot)) {
+		Vehicle *v = GetVehicle(vehicle);
+		Depot *d = GetDepot(depot);
+		/* max train lenght = 100 */ 
+		TileIndex old_tile[100];
+		DiagDirection old_dir[100];
+		uint counter;
+		uint x;
+		uint y;
+		switch (v->type) {
+			case VEH_TRAIN:
+				//old_tile[] = v->tile;
+				//old_dir[] = DirToDiagDir(v->direction);
+				counter = 0;
+				for (; v != NULL; v = GetNextVehicle(v)) {					
+					old_tile[counter] = v->tile;
+					old_dir[counter] = DirToDiagDir(v->direction);
+					counter++;
+
+					DiagDirection dir = GetRailDepotDirection(d->xy);
+					MarkSingleVehicleDirty(v);
+					v->direction = DiagDirToDir(dir);
+					v->tile = d->xy;
+					x = TileX(d->xy) * TILE_SIZE | _vehicle_initial_x_fract[dir];
+					y = TileY(d->xy) * TILE_SIZE | _vehicle_initial_y_fract[dir];
+					v->x_pos = x;
+					v->y_pos = y;
+					v->z_pos = GetSlopeZ(x, y);
+					v->vehstatus = VS_HIDDEN | VS_STOPPED | VS_DEFPAL;
+					v->u.rail.track = TRACK_BIT_DEPOT;
+					v->cur_speed = 0;
+
+					DEBUG (misc, 4, "3- Teleport v %d in depot %d", v->index, d->index);
+				}
+				/* now that vehicle is removed, clear signal */
+				for (uint i = 0; i < counter; i++) {
+					DEBUG(misc, 4, "3- update signal (dir : %d) at tile %d,%d", old_dir[i], TileX(old_tile[i]), TileY(old_tile[i]) );
+					if (i != counter) {
+						TrainMovedChangeSignals(old_tile[i], old_dir[i]);
+						//UpdateSignalsOnSegment(old_tile[i], old_dir[i], GetTileOwner(old_tile[i]));
+					} else {
+						//UpdateSignalsOnSegment(old_tile[i], ReverseDiagDir(old_dir[i]), GetTileOwner(old_tile[i]));
+						TrainMovedChangeSignals(old_tile[i], ReverseDiagDir(old_dir[i]));
+					}
+				}
+				break;
+			case VEH_ROAD:
+				MarkSingleVehicleDirty(v);
+				v->tile = d->xy;
+				x = TileX(d->xy) * TILE_SIZE + TILE_SIZE / 2;
+				y = TileY(d->xy) * TILE_SIZE + TILE_SIZE / 2;
+				v->x_pos = x;
+				v->y_pos = y;
+				v->z_pos = GetSlopeZ(x, y);
+				v->vehstatus = VS_HIDDEN | VS_STOPPED | VS_DEFPAL;
+				v->u.road.state = RVSB_IN_DEPOT;	
+				v->cur_speed = 0;
+				DEBUG (misc, 4, "3- Teleport v %d in depot %d", v->index, d->index);
+				InvalidateWindowData(WC_VEHICLE_DEPOT, v->tile);
+				break;
+			case VEH_SHIP:
+				v->tile = d->xy;
+				x = TileX(d->xy) * TILE_SIZE + TILE_SIZE / 2;
+				y = TileY(d->xy) * TILE_SIZE + TILE_SIZE / 2;
+				v->x_pos = x;
+				v->y_pos = y;
+				v->z_pos = GetSlopeZ(x, y);
+				v->vehstatus = VS_HIDDEN | VS_STOPPED | VS_DEFPAL;
+				v->u.ship.state = TRACK_BIT_DEPOT;	
+				v->cur_speed = 0;
+				DEBUG (misc, 4, "3- Teleport v %d in depot %d", v->index, d->index);
+				InvalidateWindowData(WC_VEHICLE_DEPOT, v->tile);
+				break;
+			default: break;
+		}
+		return true;
+	}
+	return false;
+}
+
+bool SharedCloseHangarTeleport (VehicleID vehicle, StationID station)
+{
+	if (IsValidStationID(station)) {
+		Vehicle *v = GetVehicle(vehicle);
+		Station *st = GetStation(station);
+		const AirportFTAClass *apc = st->Airport();
+		uint x;
+		uint y;
+
+		/* get tile of first hangar */
+		TileIndex tile = st->airport_tile + ToTileIndexDiff(apc->airport_depots[0]);
+		
+		/* we need to handle shadow & rotor */
+		Vehicle *u = v->next;
+
+		v->direction = DIR_SE;
+		v->tile = tile;
+
+		x = TileX(tile) * TILE_SIZE + 5;
+		y = TileY(tile) * TILE_SIZE + 3;
+
+		v->x_pos = u->x_pos = x;
+		v->y_pos = u->y_pos = y;
+		u->z_pos = GetSlopeZ(x, y);
+		v->z_pos = u->z_pos + 1;
+
+		v->vehstatus = VS_HIDDEN | VS_STOPPED | VS_DEFPAL;
+		u->vehstatus |= VS_HIDDEN;
+		v->UpdateDeltaXY(INVALID_DIR);
+		u->UpdateDeltaXY(INVALID_DIR);
+
+		/* set v position to first hangar */
+		v->u.air.pos = apc->layout[0].position;
+		v->u.air.state = HANGAR;
+		v->u.air.previous_pos = v->u.air.pos;
+		v->u.air.targetairport = GetStationIndex(tile);
+
+		/* handle rotor */
+		u = u->Next();
+		if (u != NULL) {
+			u->vehstatus |= VS_HIDDEN;
+			u->cur_speed = 0;
+		}
+		InvalidateWindowData(WC_VEHICLE_DEPOT, v->tile);
+		return true;
+	}
+	return false;
+}
+
+DepotID SharedCloseGetFirstDepot (PlayerID old_player, VehicleID vehicle, bool just_old_player)
+{
+	Vehicle *v = GetVehicle(vehicle);
+	Depot *depot;
+	DEBUG (misc, 4, "1- Starting search of depot for v %d", v->index);
+	FOR_ALL_DEPOTS(depot) {
+		bool owner_check = just_old_player ? (GetTileOwner(depot->xy) == old_player) : (GetTileOwner(depot->xy) != old_player);
+		switch (v->type) {
+			case VEH_TRAIN:
+				/* and check rail type */
+				if (owner_check && IsRailDepotTile(depot->xy) &&
+					(IsFreeWagon(v) || IsFrontEngine(v)) &&
+					(HasBit(v->u.rail.compatible_railtypes, GetRailType(depot->xy)))) {
+					DEBUG (misc, 4, "1- Check if v %d can access depot %d", v->index, depot->index);
+					if (SharedRailwayDepots(depot->xy, v->owner)) return depot->index;
+				}
+				break;
+			case VEH_ROAD:
+				/* tram use special depot */
+				if (owner_check && IsRoadDepotTile(depot->xy) &&
+					(HasTileRoadType(depot->xy, ROADTYPE_TRAM) == HasBit(EngInfo(v->engine_type)->misc_flags, EF_ROAD_TRAM))) {
+					DEBUG (misc, 4, "1- Check if v %d can access depot %d", v->index, depot->index);
+					if (SharedRoadDepots(depot->xy, v->owner)) return depot->index;
+				}
+				break;
+			case VEH_SHIP:
+				/* tram use special depot */
+				if (owner_check && IsShipDepotTile(depot->xy)) {
+					DEBUG (misc, 4, "1- Check if v %d can access depot %d", v->index, depot->index);
+					if (SharedWaterDepots(depot->xy, v->owner)) return depot->index;
+				}
+				break;
+			default: break;
+		}
+	}
+	DEBUG (misc, 4, "1- No valid depot for v %d", v->index);
+	return INVALID_DEPOT;
+}
+
+StationID SharedCloseGetFirstHangar(PlayerID old_player, VehicleID vehicle, bool check_player)
+{	
+	Vehicle *v = GetVehicle(vehicle);
+	Station *st;
+	DEBUG (misc, 4, "1- Starting search of hangar for v %d", v->index);
+	FOR_ALL_STATIONS(st) {
+		if (((st->owner == old_player) || (!SharedAirports(st->xy, v->owner))) || !(st->facilities & FACIL_AIRPORT)) continue;
+		DEBUG (misc, 4, "1- Check if airport %d is compatible with v %d", st->index, v->owner);
+		const AirportFTAClass *afc = st->Airport();
+		if (afc->flags & (v->subtype == AIR_HELICOPTER ? AirportFTAClass::HELICOPTERS : AirportFTAClass::AIRPLANES) &&
+			afc->nof_depots > 0) return st->index;
+	}
+	return INVALID_STATION;
+}
+
+void UpdateSharedOnRemove(VehicleID vehicle)
+{
+	Vehicle *v = GetVehicle(vehicle);
+	switch (v->type) {
+		case VEH_TRAIN:
+			if (v->current_order.IsType(OT_LOADING)) {
+				DEBUG (misc, 4, "2- v %d was loading, clear station", v->index);
+				v->LeaveStation();
+				v->load_unload_time_rem = 0;
+			}
+			break;
+		case VEH_ROAD:
+			if (v->current_order.IsType(OT_LOADING)) {
+				DEBUG (misc, 4, "2- v %d was loading, clear station", v->index);
+				v->LeaveStation();
+			}
+			ClearSlot(v);
+			break;
+		case VEH_SHIP:
+			/* ship does not block station */
+			break;			
+		case VEH_AIRCRAFT:
+			if (v->u.air.state != FLYING && v->u.air.state != HANGAR) {
+				DEBUG (misc, 4, "2- v %d was on ground, clear station", v->index);
+				Station *old_st = GetStation (v->u.air.targetairport);
+				const AirportFTAClass *apc = old_st->Airport();
+				CLRBITS(old_st->airport_flags, apc->layout[v->u.air.pos].block);
+			}
+			break;
+		default: NOT_REACHED();
+	}
+
+}
+
+void SharedCloseOnLand (PlayerID old_player, VehicleID vehicle)
+{
+	DEBUG (misc, 4, "1- find first available depot for v %d", vehicle);
+	DepotID depot = SharedCloseGetFirstDepot (old_player, vehicle, false);
+	Vehicle *v = GetVehicle(vehicle);
+	PlayerID curr = _current_player;
+	bool handled = false;
+	DEBUG (misc, 4, "1- save vehicle position : tile %d", v->tile);
+	TileIndex old_tile = v->tile;
+	uint command;
+
+	/* vehicle and infrastructure need some resetting */
+	UpdateSharedOnRemove(vehicle);
+
+	DEBUG (misc, 4, "2- start handling of v %d (type : %d) for depot %d", v->index, v->type, depot);
+
+	if (IsValidDepotID(depot)) {
+		/* try to send vehicle to new depot, on fail try another way */
+		DEBUG (misc, 4, "2- try to send v %d to depot %d", v->index, depot);
+		handled = SharedCloseDepotTeleport(vehicle, depot);
+	} else {
+		/* sell vehicle */
+		int sell_cmd = 0;
+		switch (v->type) {
+			case VEH_TRAIN:
+				if (IsFrontEngine(v)) sell_cmd = 1;
+				command = CMD_SELL_RAIL_WAGON;
+				break;
+			case VEH_ROAD:
+				command = CMD_SELL_ROAD_VEH;
+				break;
+			case VEH_SHIP:
+				command = CMD_SELL_SHIP;
+				break;
+			default:
+				NOT_REACHED();
+				command = 0;
+		}
+		_current_player = v->owner;
+		/* already in old_player depot ? then sell vehicle */
+		if (v->IsStoppedInDepot()) {		
+			DEBUG (misc, 4, "3- sending to shared depot failed, v %d already in closing depot, trying to sell", v->index, depot);	
+			CommandCost cost = DoCommand(0, v->index, sell_cmd, DC_EXEC, command);
+			SubtractMoneyFromPlayer(cost);
+			if (v->owner == _local_player && cost.GetCost() != 0) {
+				ShowCostOrIncomeAnimation(v->x_pos, v->y_pos, v->z_pos, cost.GetCost());
+			}
+			handled = CmdSucceeded(cost);
+		} else {
+			/* We have already tested all depots except old_player's. do it now */ 
+			DEBUG (misc, 4, "3- sending to shared depot failed for v %d, trying closing depot", v->index, depot);
+			DepotID depot = SharedCloseGetFirstDepot (old_player, vehicle, true);
+			if (SharedCloseDepotTeleport(vehicle, depot)) {
+				/* vehicule finally in depot now ? sell it */
+				DEBUG (misc, 4, "3- try to sell v %d in closing depot", v->index, depot);
+				CommandCost cost = DoCommand(0, v->index, sell_cmd, DC_EXEC, command);
+				SubtractMoneyFromPlayer(cost);
+				if (v->owner == _local_player && cost.GetCost() != 0) {
+					ShowCostOrIncomeAnimation(v->x_pos, v->y_pos, v->z_pos, cost.GetCost());
+				}
+				handled = CmdSucceeded(cost);
+			}
+		}
+	}
+	if (!handled) {
+		/* tried everything possible to save it, without success, now just delete this vehicle */
+		DEBUG (misc, 4, "4- tried anything, deleting v %d (subtype %d)", v->index, v->subtype);
+		DeleteWindowById(WC_VEHICLE_VIEW, v->index);
+		DeleteWindowById(WC_VEHICLE_DETAILS, v->index);
+		DeleteWindowById(WC_VEHICLE_ORDERS, v->index);
+		switch (v->type) {
+			case VEH_TRAIN:
+				if (IsFrontEngine(v)) for (; v != NULL; v = GetNextVehicle(v)) {
+					DEBUG (misc, 4, "4- tried anything, deleting v %d in chain", v->index);
+					old_tile = v->tile;
+					DiagDirection old_dir = DirToDiagDir(v->direction);
+					delete v;
+					/* now that vehicle is removed, clear signal */
+					DEBUG(misc, 4, "dir : %d", old_dir);
+					UpdateSignalsOnSegment(old_tile, old_dir, GetTileOwner(old_tile));
+					DEBUG (misc, 4, "4- tried anything, v %d deleted in chain", v->index);
+				} else {
+					DEBUG (misc, 4, "4- tried anything, deleting v %d alone", v->index);
+					old_tile = v->tile;
+					DiagDirection old_dir = DirToDiagDir(v->direction);
+					delete v;
+					/* now that vehicle is removed, clear signal */
+					DEBUG(misc, 4, "dir : %d", old_dir);
+					UpdateSignalsOnSegment(old_tile, old_dir, GetTileOwner(old_tile));
+					DEBUG (misc, 4, "4- tried anything, v %d deleted alone", v->index);
+				}
+				break;
+			case VEH_ROAD:
+			case VEH_SHIP:
+				DEBUG (misc, 4, "4- tried anything, deleting v %d", v->index);
+				delete v;
+				DEBUG (misc, 4, "4- tried anything, v %d deleted", v->index);
+				break;
+			default: NOT_REACHED(); command = 0;
+		}
+
+	}
+	_current_player = curr;
+	/* clean some more infrastructure */
+
+	DEBUG (misc, 4, "5- end of handling v %d", vehicle);
+}
+
+void SharedCloseOnAir (PlayerID old_player, VehicleID vehicle)
+{
+	DEBUG (misc, 4, "1- find first available hangar for v %d", vehicle);
+	StationID airport = SharedCloseGetFirstHangar(old_player, vehicle, false);
+	Vehicle *v = GetVehicle(vehicle);
+	PlayerID curr = _current_player;
+	bool handled = false;
+
+	/* vehicle on airport need some resetting */
+	UpdateSharedOnRemove(vehicle);
+
+	DEBUG (misc, 4, "2- start handling of v %d (type : %d) for airport %d", v->index, v->type, airport);
+
+	if (IsValidStationID(airport)) {
+		/* try to send vehicle to new depot, on fail try another way */
+		DEBUG (misc, 4, "2- try to send v %d to airport %d", v->index, airport);
+		handled = SharedCloseHangarTeleport(vehicle, airport);
+	} else {
+		/* sell vehicle */
+		_current_player = v->owner;
+		/* already in old_player depot ? then sell vehicle */
+		if (v->IsStoppedInDepot()) {		
+			DEBUG (misc, 4, "3- sending to shared hangar failed, v %d already in closing hangar, trying to sell", v->index, airport);	
+			handled = CmdSucceeded(DoCommand(0, v->index, 0, DC_EXEC, CMD_SELL_AIRCRAFT));
+		} else {
+			/* We have already tested all depots except old_player's. do it now */ 
+			DEBUG (misc, 4, "3- sending to shared hangar failed for v %d, trying closing hangar", v->index, airport);
+			airport = SharedCloseGetFirstHangar (old_player, vehicle, true);
+			if (SharedCloseHangarTeleport(vehicle, airport)) {
+				/* vehicule finally in depot now ? sell it */
+				DEBUG (misc, 4, "3- try to sell v %d in closing hangar", v->index, airport);
+				handled = CmdSucceeded(DoCommand(0, v->index, 0, DC_EXEC, CMD_SELL_AIRCRAFT));
+			}
+		}
+	}
+	if (!handled) {
+		/* tried everything possible to save it, without success, now just delete this vehicle */
+		DEBUG (misc, 4, "4- tried anything, deleting v %d (subtype %d)", v->index, v->subtype);
+		DeleteWindowById(WC_VEHICLE_VIEW, v->index);
+		DeleteWindowById(WC_VEHICLE_DETAILS, v->index);
+		DeleteWindowById(WC_VEHICLE_ORDERS, v->index);
+
+		DEBUG (misc, 4, "4- tried anything, deleting v %d", v->index);
+		DeleteVehicleChain(v);
+		DEBUG (misc, 4, "4- tried anything, v %d deleted", v->index);
+
+	} else {
+		/* post-teleport */
+
+	}
+	_current_player = curr;
+	DEBUG (misc, 4, "5- end of handling v %d", vehicle);
+
+}
+
+/** Take care of vehicle on closed shared infrastructure.
+ * @param old_player bankrupt player
+ */
+void OnSharedClose(PlayerID old_player, uint close_bits)
+{	
+	DEBUG (misc, 4, "0- player %d is closing those bits : %d", old_player, close_bits);
+	Vehicle *v;	
+	Station *st = NULL;
+	FOR_ALL_VEHICLES(v) {
+		switch (v->type){
+			case VEH_TRAIN:
+				/* attached wagons are handled with front engines later */
+				if (GetTileOwner(v->tile) == old_player && (IsFrontEngine(v) || IsFreeWagon(v)) &&
+					((HASBITS(close_bits, SHARED_RAILWAY_TRACKS))
+					|| (HASBITS(close_bits, SHARED_RAILWAY_STATIONS) && IsTileType(v->tile, MP_STATION))
+					|| (HASBITS(close_bits, SHARED_RAILWAY_DEPOTS) && IsDepotTypeTile(v->tile, TRANSPORT_RAIL) ))) {
+					DEBUG (misc, 4, "0- v %d is TRAIN, owned by player %d in tile %d,%d", v->index, v->owner, TileX(v->tile),TileY(v->tile));
+					SharedCloseOnLand (old_player, v->index);
+				}
+				break;
+			case VEH_ROAD:
+				/* road won't be removed, check only in depot and stations */
+				if (GetTileOwner(v->tile) == old_player && 
+					((IsDepotTypeTile(v->tile, TRANSPORT_ROAD) && HASBITS(close_bits, SHARED_ROAD_DEPOTS))
+					|| ((IsTileType(v->tile, MP_STATION)) && HASBITS(close_bits, SHARED_ROAD_STOPS)))) {
+					DEBUG (misc, 4, "0- v %d is ROAD, owned by player %d in tile %d,%d", v->index, v->owner, TileX(v->tile),TileY(v->tile));
+					SharedCloseOnLand (old_player, v->index);
+				}
+				break;
+			case VEH_SHIP: 
+				/* remove ships in shared depots */
+				if (GetTileOwner(v->tile) == old_player && (IsDepotTypeTile(v->tile, TRANSPORT_WATER))
+					&& HASBITS(close_bits, SHARED_WATER_DEPOTS)) {
+					DEBUG (misc, 4, "0- v %d is SHIP, owned by player %d in tile %d,%d", v->index, v->owner, TileX(v->tile),TileY(v->tile));
+					SharedCloseOnLand (old_player, v->index); // TODO : find another name to this function
+				}
+				break;
+			case VEH_AIRCRAFT:
+				/* don't land on closing airports */
+				st = GetStation(v->u.air.targetairport);
+				if (((v->u.air.state == LANDING && st->owner == old_player) ||
+					(v->u.air.state != FLYING && (GetTileOwner(v->tile) == old_player)))
+					&& HASBITS(close_bits, SHARED_AIRPORTS)) {
+					DEBUG (misc, 4, "0- v %d is AIRCRAFT, owned by player %d in tile %d,%d", v->index, v->owner, TileX(v->tile),TileY(v->tile));
+					SharedCloseOnAir (old_player, v->index);
+				}
+				break;
+			default: break;
+		}
+	}
+}
